#!/bin/bash

# This is a wrapper for worker.php, to not wait a lot after it exits

. /usr/share/rocketgit/scripts/common.sh

check_context

exec 100<>/var/lib/rocketgit/locks/worker.sh.lock

flock --exclusive --nonblock 100
if [ "${?}" != "0" ]; then
	exit 0
fi

while [ 1 ]; do
	php /usr/share/rocketgit/scripts/worker.php

	# in case of errors, we will wait, to not go into an infinite loop
	if [ "${?}" != "0" ]; then
		sleep 10
	else
		sleep 1
	fi
done

flock --unlock 100
